(**************************************************************************)
(* BINARY HEX and OCTAL CONVERSION ROUTINES *)
function hex( anibble : byte) : char;
const
     hexst : array[0..15] of char = '0123456789ABCDEF';
begin
     hex:=hexst[anibble];
end;

function hex2( abyte : byte) : string;
begin
     hex2:=hex(abyte div 16)+hex(abyte mod 16);
end;

function hex4( aword : longint) : string;
begin
     hex4:=hex2(aword div 256)+hex2(aword mod 256);
end;

function bin8( abyte : byte) : string;
var
   i : integer;
   S : array[0..7] of char;
begin
     for i:=7 downto 0 do
     begin
          if odd(abyte) then s[i]:='1'
             else s[i]:='0';
          abyte:=abyte div 2;
     end;
     bin8:=s;
end;

function bin16(aword : word) : string;
begin
     bin16:=bin8(aword div 256)+'.'+bin8(aword mod 256);
end;

function oct( aword : word) : string;
var
   o1,o2,o3,o4 : byte;
   str : string[8];
begin
     o4:=aword and 7;
     o3:=(aword and $38) div 8;
     o2:=(aword and $1c0) div 64;
     o1:=(aword and $e00) div 512;
     oct:=hex(o1)+hex(o2)+hex(o3)+hex(o4);
end;

function oct_to_word(oct4 : string) : word;
var
   o1,o2,o3,o4 : byte;

begin
     o1:=ord(oct4[1])-$30;
     o2:=ord(oct4[2])-$30;
     o3:=ord(oct4[3])-$30;
     o4:=ord(oct4[4])-$30;
     oct_to_word:=(o1*512) or (o2*64) or (o3*8) or o4;
end;
(************************************************************************)
(* END OF BINARY/HEX and OCTAL CONVERSION ROUTINES *)
(**************************************************************************)
